unit lazbridge;

{$MODE objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, GraphType, InterfaceBase, LCLType, opbitmap, intfgraphics, fpimage, LCLIntf;


type

{ TMyIntfImage }

  TMyIntfImage = class(TLazIntfImage)
  public
    procedure CreateBitmapLateMask(var Bitmap, MaskBitmap: HBitmap;
      AlwaysCreateMask: boolean; const RawImage: TRawImage);
  end;

procedure AssignBitmapToOpBitmap(Bitmap: TBitmap; OpBitmap: TOpBitmap);


procedure AssignOpBitmapToBitmap(SourceBitmap: TOpBitmap; Bitmap: TBitmap; PreserveFormat:boolean=true);
procedure AssignOpBitmapToCanvas(OpBitmap: TOpBitmap; aCanvas: Graphics.TCanvas; X,Y:integer);

implementation

procedure AssignBitmapToOpBitmap(Bitmap: TBitmap; OpBitmap: TOpBitmap);
begin
//Todo:Implement, not needed here
end;


procedure AssignOpBitmapToBitmap(SourceBitmap: TOpBitmap; Bitmap: TBitmap; PreserveFormat:boolean=true);
var int: TMyIntfImage;
var bmph, mbmph: HBitmap;
  x, y: integer;
  pmask: PByte;
  rawi: TRawImage;
  OPBitmap:TOpBitmap;
begin
  if PreserveFormat then
  begin
  OpBitmap:=TOPBitmap.create;
  OpBitmap.Assign(SourceBitmap);
  end else OpBitmap:=SourceBitmap;

  Int := TMyIntfImage.Create(0, 0);
  Int.AutoCreateMask := false;
  Int.GetDescriptionFromDevice(0);
  Int.Width := OpBitmap.Width;
  Int.Height := OpBitmap.Height;
  OpBitmap.Pixelformat := PixelFormatFromBPP(Int.DataDescription.BitsPerPixel);
  for y := 0 to OpBitmap.Height - 1 do
    for x := 0 to OpBitmap.Width - 1 do
      Int.TColors[X, Y] := OpBitmap.Pixels[X, Y];

  if OPBitmap.Transparent then
  begin
    int.GetRawImage(Rawi);
    rawi.MaskSize := OpBitmap.GetTransparentMask(0, pmask,
      Rawi.Description.AlphaBitOrder = riboReversedBits,
      Rawi.Description.AlphaLineEnd = rileWordBoundary);
    rawi.Mask := pmask;
    Int.CreateBitmapLateMask(bmph, mbmph, false, rawi);
  end else
  begin
    Int.CreateBitmap(bmph, mbmph, false);
  end;

  Bitmap.Handle := bmph;
  Bitmap.MaskHandle := mbmph;
  Int.free;
  if PreserveFormat then OPBitmap.free;
end;

procedure AssignOpBitmapToCanvas(OpBitmap: TOpBitmap; aCanvas: Graphics.TCanvas; X,Y:integer);
var Bmp:TBitmap;
begin
Bmp:=TBitmap.create;
AssignOpBitmapToBitmap(OpBitmap,Bmp);
aCanvas.Draw(X, Y, bmp);
Bmp.free;
end;



{ TMyIntfImage }

procedure TMyIntfImage.CreateBitmapLateMask(var Bitmap, MaskBitmap: HBitmap;
  AlwaysCreateMask: boolean; const RawImage: TRawImage);
var
  ARawImage: TRawImage;
begin
  GetRawImage(ARawImage);
  ARawImage.Mask := RawImage.Mask;
  ARawImage.MaskSize := RawImage.MaskSize;
  if not CreateBitmapFromRawImage(ARawImage, Bitmap, MaskBitmap, AlwaysCreateMask)
    then
    raise FPImageException.Create('Failed to create bitmaps');
end;

end.
